execute if score exploded_red match_variable matches 1 run scoreboard players set replace_wool temp 1
execute if entity @a[tag=has_red_wool] run scoreboard players set missing_wool temp 1
execute if entity @e[tag=lost_red_wool] run scoreboard players set missing_wool temp 1
execute if score red_wool match_variable matches 11 run scoreboard players set missing_wool temp 1

# Wool detection
tag @a[team=blue,nbt={Inventory:[{id:"minecraft:red_wool"}]}] add took_red_wool
scoreboard players operation amount temp = shards_per_steal CONSTANT
execute as @a[tag=took_red_wool] run function ctw:z_fct/match/economy/give_shards
clear @a[tag=took_red_wool] red_wool
execute if entity @a[tag=has_red_wool] run tag @a remove took_red_wool
execute as @a[tag=took_red_wool] run tellraw @a [{"text":"\u25b6 "},{"selector":"@s"},{"text":" just stole the "},{"text":"Red wool","color":"red"},{"text":" !"}]
execute if entity @a[tag=took_red_wool] run playsound minecraft:item.trident.thunder ambient @a 65 57 155 1 1.8 1
execute if score Red worshippers matches 1.. run title @a[tag=took_red_wool] times 0 50 20
execute if score Red worshippers matches 1.. run title @a[tag=took_red_wool] title {"text":"Cursed","bold":true,"color":"white"}
execute if score Red worshippers matches 1.. run title @a[tag=took_red_wool] subtitle {"text":"by the worshippers","bold":true,"color":"white"}
tag @a[tag=took_red_wool] add has_red_wool
tag @a remove took_red_wool

# Death
execute if entity @a[tag=has_red_wool,tag=died] run scoreboard players operation red lost_wool_delay = lost_wool_despawn_time CONSTANT
execute if entity @a[tag=has_red_wool,tag=died] run summon falling_block 0 250 0 {Time:-2147483648,Invulnerable:1b,NoGravity:1b,BlockState:{Name:red_wool},CustomNameVisible:1b,Tags:["lost_red_wool"]}
execute store result entity @e[tag=lost_red_wool,limit=1] Pos[0] double 1 run scoreboard players get redW_x pos
execute store result entity @e[tag=lost_red_wool,limit=1] Pos[1] double 1 run scoreboard players get redW_y pos
execute store result entity @e[tag=lost_red_wool,limit=1] Pos[2] double 1 run scoreboard players get redW_z pos
execute as @e[tag=lost_red_wool] at @s run tp @s ~0.5 ~0.5 ~0.5
tag @a[tag=died] remove has_red_wool

# Coordinate
execute as @a[tag=has_red_wool,limit=1,nbt={OnGround:1b}] store result score redW_x pos run data get entity @s Pos[0]
execute as @a[tag=has_red_wool,limit=1,nbt={OnGround:1b}] store result score redW_y pos run data get entity @s Pos[1]
execute as @a[tag=has_red_wool,limit=1,nbt={OnGround:1b}] store result score redW_z pos run data get entity @s Pos[2]

# Follow effects
execute at @e[tag=red_wool] if entity @a[tag=has_red_wool,distance=25..] run scoreboard players set wool_too_far temp 1
execute unless score wool_too_far temp matches 1 run kill @e[tag=red_wool]
execute unless score wool_too_far temp matches 1 at @a[tag=has_red_wool] run summon falling_block ~ ~2.5 ~ {Time:-2147483648,Invulnerable:1b,NoGravity:1b,BlockState:{Name:red_wool},CustomName:'{"text":"Red wool","color":"red","bold":true}',CustomNameVisible:1b,Tags:["red_wool"]}
effect give @a[tag=has_red_wool] glowing 1 0 true
execute at @e[tag=red_wool] run particle minecraft:dust 1.0 0.0 0.0 1 ~ ~0.5 ~ 0.5 0.5 0.5 1 3

# TP too far
execute if score wool_too_far temp matches 1 run tellraw @a[tag=has_red_wool] [{"text":"\u25b6 "},{"text":"You teleported too far and lost the "},{"text":"Red wool","color":"red"},{"text":" !"}]
execute if score wool_too_far temp matches 1 run scoreboard players operation red lost_wool_delay = lost_wool_despawn_time CONSTANT
execute if score wool_too_far temp matches 1 at @e[tag=red_wool] run summon falling_block 0 250 0 {Time:-2147483648,Invulnerable:1b,NoGravity:1b,BlockState:{Name:red_wool},CustomNameVisible:1b,Tags:["lost_red_wool"]}
execute if score wool_too_far temp matches 1 run kill @e[tag=red_wool]
execute if score wool_too_far temp matches 1 run tag @a remove has_red_wool
scoreboard players reset wool_too_far temp

# Lost wool
execute at @e[tag=lost_red_wool] run tag @a[team=blue,distance=..1.5,limit=1,sort=nearest,tag=!died] add took_red_wool
execute at @a[tag=took_red_wool] run playsound minecraft:entity.sheep.ambient player @a ~ ~ ~ 2 1.5 0.2
execute if score Red worshippers matches 1.. run title @a[tag=took_red_wool] times 0 50 20
execute if score Red worshippers matches 1.. run title @a[tag=took_red_wool] title {"text":"Cursed","bold":true,"color":"white"}
execute if score Red worshippers matches 1.. run title @a[tag=took_red_wool] subtitle {"text":"by the worshippers","bold":true,"color":"white"}
tag @a[tag=took_red_wool] add has_red_wool
tag @a remove took_red_wool
execute if entity @a[tag=has_red_wool] run kill @e[tag=lost_red_wool]
execute at @e[tag=lost_red_wool] run particle minecraft:dust 1.0 0.0 0.0 1 ~ ~ ~ 0 15 0 1 70 force

# Delay
execute unless score accelerated match_variable matches 1 if entity @e[tag=lost_red_wool] run scoreboard players remove red lost_wool_delay 1
scoreboard players operation red_lost_wool_delay temp = red lost_wool_delay
scoreboard players operation red_lost_wool_delay temp /= 20 NUM
data modify block 2000 100 0 Text1 set value '[{"text":"Red wool","bold":true,"color":"red"},{"text":" - ","color":"red"},{"score":{"name":"red_lost_wool_delay","objective":"temp"},"color":"red"},{"text":"s","color":"red"}]'
data modify entity @e[tag=lost_red_wool,limit=1] CustomName set from block 2000 100 0 Text1

# End delay
execute if score red lost_wool_delay matches 0 at @e[tag=lost_red_wool] run playsound minecraft:block.fire.extinguish block @a ~ ~ ~ 1 1 1
execute if score red lost_wool_delay matches 0 run kill @e[tag=lost_red_wool]
execute if score red lost_wool_delay matches 0 run tellraw @a [{"text":"\u25b6 "},{"text":"The "},{"text":"Red wool","color":"red"},{"text":" has been returned."}]
execute if score red lost_wool_delay matches 0 run scoreboard players set replace_wool temp 1
execute if score red lost_wool_delay matches 0 run scoreboard players set red lost_wool_delay -1

# Put wool
execute unless score red_wool match_variable matches 11 run fill -7 44 -156 -7 47 -156 air
execute as @a[x=-8,y=43,z=-157,dx=2,dy=6,dz=2,tag=has_red_wool] run function ctw:z_fct/match/wools/put_red_wool
execute if score red_wool match_variable matches 11 run setblock -7 44 -156 red_wool

# Setblocks
execute unless score missing_wool temp matches 1 run fill 64 51 154 66 51 156 iron_block
execute unless score missing_wool temp matches 1 run setblock 65 52 155 beacon
execute if score missing_wool temp matches 1 run setblock 65 52 155 bedrock
execute unless score missing_wool temp matches 1 run setblock 65 53 155 red_stained_glass
execute unless score missing_wool temp matches 1 run setblock 65 54 155 red_stained_glass
execute unless score missing_wool temp matches 1 run setblock 65 55 155 water
execute unless score missing_wool temp matches 1 run setblock 65 56 155 air
execute unless score red_wool match_variable matches 11 unless block 65 57 155 red_shulker_box run setblock 65 57 155 red_shulker_box[facing=down]
execute unless score missing_wool temp matches 1 if score t20 tick_cycle matches 1 run fill 65 58 155 65 91 155 red_stained_glass
execute unless score missing_wool temp matches 1 if score t20 tick_cycle matches 1 run fill 65 92 155 65 140 155 air destroy

# Wool replacement
execute if entity @e[type=item,nbt={Item:{id:"minecraft:red_wool"}}] run scoreboard players set replace_wool temp 1
execute if entity @e[type=item,nbt={Item:{id:"minecraft:red_shulker_box"}}] run scoreboard players set replace_wool temp 1
kill @e[type=item,nbt={Item:{id:"minecraft:red_wool"}}]
kill @e[type=item,nbt={Item:{id:"minecraft:red_shulker_box"}}]
execute if entity @a[team=red,nbt={Inventory:[{id:"minecraft:red_wool"}]}] run scoreboard players set replace_wool temp 1
execute as @a[team=red,nbt={Inventory:[{id:"minecraft:red_wool"}]}] run clear @s red_wool

execute if score replace_wool temp matches 1 run data modify block 65 57 155 Items append value {Slot:13b,id:red_wool,Count:1b}
scoreboard players reset replace_wool temp
scoreboard players reset missing_wool temp
