# Count
scoreboard players set Blue worshippers 0
execute as @e[tag=blue_worshipper] run scoreboard players add Blue worshippers 1
scoreboard players set Cyan worshippers 0
execute as @e[tag=cyan_worshipper] run scoreboard players add Cyan worshippers 1
scoreboard players set Red worshippers 0
execute as @e[tag=red_worshipper] run scoreboard players add Red worshippers 1
scoreboard players set Pink worshippers 0
execute as @e[tag=pink_worshipper] run scoreboard players add Pink worshippers 1

# Message
execute unless score blue_worshippers_killed match_variable matches 1 if score Blue worshippers matches 0 run scoreboard players set all_killed temp 1
execute if score all_killed temp matches 1 run tellraw @a [{"text":"\u25b6 The "},{"text":"Blue wool","color":"blue"},{"text":" has no more worshippers !"}]
execute if score all_killed temp matches 1 run kill @e[tag=protected_blue]
execute if score all_killed temp matches 1 run scoreboard players set blue_worshippers_killed match_variable 1
scoreboard players reset all_killed temp

execute unless score cyan_worshippers_killed match_variable matches 1 if score Cyan worshippers matches 0 run scoreboard players set all_killed temp 1
execute if score all_killed temp matches 1 run tellraw @a [{"text":"\u25b6 The "},{"text":"Cyan wool","color":"aqua"},{"text":" has no more worshippers !"}]
execute if score all_killed temp matches 1 run kill @e[tag=protected_cyan]
execute if score all_killed temp matches 1 run scoreboard players set cyan_worshippers_killed match_variable 1
scoreboard players reset all_killed temp

execute unless score red_worshippers_killed match_variable matches 1 if score Red worshippers matches 0 run scoreboard players set all_killed temp 1
execute if score all_killed temp matches 1 run tellraw @a [{"text":"\u25b6 The "},{"text":"Red wool","color":"red"},{"text":" has no more worshippers !"}]
execute if score all_killed temp matches 1 run kill @e[tag=protected_red]
execute if score all_killed temp matches 1 run scoreboard players set red_worshippers_killed match_variable 1
scoreboard players reset all_killed temp

execute unless score pink_worshippers_killed match_variable matches 1 if score Pink worshippers matches 0 run scoreboard players set all_killed temp 1
execute if score all_killed temp matches 1 run tellraw @a [{"text":"\u25b6 The "},{"text":"Pink wool","color":"light_purple"},{"text":" has no more worshippers !"}]
execute if score all_killed temp matches 1 run kill @e[tag=protected_pink]
execute if score all_killed temp matches 1 run scoreboard players set pink_worshippers_killed match_variable 1
scoreboard players reset all_killed temp

# Limitations
execute if score Blue worshippers matches 13.. run kill @e[tag=blue_worshipper,limit=1,sort=random]
execute if score Cyan worshippers matches 13.. run kill @e[tag=cyan_worshipper,limit=1,sort=random]
execute if score Red worshippers matches 13.. run kill @e[tag=red_worshipper,limit=1,sort=random]
execute if score Pink worshippers matches 13.. run kill @e[tag=pink_worshipper,limit=1,sort=random]

# Curses
execute if score Blue worshippers matches 1.. run effect give @a[tag=has_blue_wool] slowness 1
execute if score Cyan worshippers matches 1.. run effect give @a[tag=has_cyan_wool] slowness 1
execute if score Red worshippers matches 1.. run effect give @a[tag=has_red_wool] slowness 1
execute if score Pink worshippers matches 1.. run effect give @a[tag=has_pink_wool] slowness 1
execute if score Blue worshippers matches 1.. run effect give @a[tag=has_blue_wool] darkness 5
execute if score Cyan worshippers matches 1.. run effect give @a[tag=has_cyan_wool] darkness 5
execute if score Red worshippers matches 1.. run effect give @a[tag=has_red_wool] darkness 5
execute if score Pink worshippers matches 1.. run effect give @a[tag=has_pink_wool] darkness 5
execute if score t10 tick_cycle matches 1 if score Blue worshippers matches 1.. at @a[tag=has_blue_wool,scores={hearts=6..}] run summon minecraft:lightning_bolt ~ ~ ~ {Tags:["temp"]}
execute if score t10 tick_cycle matches 1 if score Cyan worshippers matches 1.. at @a[tag=has_cyan_wool,scores={hearts=6..}] run summon minecraft:lightning_bolt ~ ~ ~ {Tags:["temp"]}
execute if score t10 tick_cycle matches 1 if score Red worshippers matches 1.. at @a[tag=has_red_wool,scores={hearts=6..}] run summon minecraft:lightning_bolt ~ ~ ~ {Tags:["temp"]}
execute if score t10 tick_cycle matches 1 if score Pink worshippers matches 1.. at @a[tag=has_pink_wool,scores={hearts=6..}] run summon minecraft:lightning_bolt ~ ~ ~ {Tags:["temp"]}
execute if score t10 tick_cycle matches 5 run kill @e[type=minecraft:lightning_bolt,tag=temp]
